package wls.tools.logreport;

/* Objet message reprsentant :
 * 
 BEA-000403 
 Error: IOException occurred on socket: socket\n ioe.

 Description 
 An IO exception was encountered while reading from the socket. 
 Cause 
 An unexpected IO exception was encountered while performing IO for the socket. 
 Action 
 Check network connectivity. If situation persists after environmental issues are resolved, contact BEA Customer Support. 
 * 
 */

public class ErrorMessage {

	String id = null;
	String validity = null;
	String severity = null;
	String severityInfo = null;
	String description = null;
	String cause = null;
	String action = null;
	
	public String getAction() {
		return action;
	}
	public void setAction(String action) {
		this.action = action;
	}
	public String getCause() {
		return cause;
	}
	public void setCause(String cause) {
		this.cause = cause;
	}
	public String getDescription() {
		return description;
	}
	public void setDescription(String description) {
		this.description = description;
	}
	public String getId() {
		return id;
	}
	public void setId(String id) {
		this.id = id;
	}
	public String getSeverity() {
		return severity;
	}
	public void setSeverity(String severity) {
		this.severity = severity;
	}
	public String getSeverityInfo() {
		return severityInfo;
	}
	public void setSeverityInfo(String severityInfo) {
		this.severityInfo = severityInfo;
	}
	public String getValidity() {
		return validity;
	}
	public void setValidity(String validity) {
		this.validity = validity;
	}
	
	public String toString() {

		StringBuffer out = new StringBuffer();
		
		out.append( " id=[" + id + "]" );
		out.append( " validity=[" + validity + "]" );
		out.append( " severityInfo=[" + severityInfo + "]" );
		out.append( " description=[" + description + "]" );
		out.append( " cause=[" + cause + "]" );
		out.append( " action=[" + action + "]" );

		return out.toString();
	}
	
	public String toCSV() {
		
		StringBuffer result = new StringBuffer();
		String message = null;
		
		message = this.validity; if( message == null || message.length() == 0 ) { message = " "; }
		result.append( Function.replace( message, Parameter.sep, "_" ) ); result.append( Parameter.sep );

		message = this.severityInfo; if( message == null || message.length() == 0 ) { message = " "; }
		result.append( Function.replace( message, Parameter.sep, "_" ) ); result.append( Parameter.sep );
		
		message = this.description; if( message == null || message.length() == 0 ) { message = " "; }
		result.append( Function.replace( message, Parameter.sep, "_" ) ); result.append( Parameter.sep );
		
		message = this.cause; if( message == null || message.length() == 0 ) { message = " "; }
		result.append( Function.replace( message, Parameter.sep, "_" ) ); result.append( Parameter.sep );
		
		message = this.action; if( message == null || message.length() == 0 ) { message = " "; }
		result.append( Function.replace( message, Parameter.sep, "_" ) ); result.append( Parameter.sep );
				
		return result.toString();
	}	
	
}
