package wls.tools.logreport;

import java.io.File;
import java.io.FilenameFilter;
import java.io.IOException;
import java.util.Vector;
import java.util.regex.Pattern;

public class Function {

//	public static Pattern p = Pattern.compile("\\W");
//	public static Pattern p = Pattern.compile("\\s+");
	
	public static void mkdir( String dirName ) {
		
		File f = new File(dirName);
		if( f.exists() ) { (new File(dirName)).delete(); } // si le repertoire existe, on le supprime
		(new File(dirName)).mkdir();
		
	}
	
	public static Vector split( String src, char startWith, char endWith ) {
		
		Vector result = new Vector();
		
		int s = 0;
		int e = 0;
		
		int startWithIn = 0;
		
		boolean in = false;
		char a = 0;
		for (int i = 0; i < src.length(); i++) {
			
			a = src.charAt(i);
			if( in && ( src.charAt(i) == startWith ) ) { 
				startWithIn++; }

			if( ( src.charAt(i) == startWith ) && ( in != true ) ) { 
				
				s = i; 
				in = true;
			};
		

			if( ( src.charAt(i) == endWith ) &&  ( in != false ) && startWithIn == 0 ) { 
				
				e = i; 
				in = false;
				
				result.add( src.substring( s+1, e) );
			}

			if( in && ( src.charAt(i) == endWith ) && startWithIn > 0 ) { 
				startWithIn--; }			
		}

		return result;
	}			
	
/*
	public static Vector split( String src, char startWith, char endWith ) {
		
		Vector result = new Vector();
		
		int s = 0;
		int e = 0;
		
		boolean in = false;
		
		for (int i = 0; i < src.length(); i++) {
			
			if( ( src.charAt(i) == startWith ) && ( in != true ) ) { 
				
				s = i; 
				in = true;
			};
			
			if( ( src.charAt(i) == endWith ) &&  ( in != false ) ) { 
				
				e = i; 
				in = false;
				
				result.add( src.substring( s+1, e).trim() );
			}
		}

		return result;
	}	
// */

/*	
	public static Vector split( String src, char startWith, char endWith ) {
		
		Vector result = new Vector();
		
		int s = 0;
		int e = 0;
		
		int startWithIn = 0;
		
		boolean in = false;
		char a = 0;
		for (int i = 0; i < src.length(); i++) {
			
			a = src.charAt(i);
			if( in && ( src.charAt(i) == startWith ) ) { 
				startWithIn++; }

			if( ( src.charAt(i) == startWith ) && ( in != true ) ) { 
				
				s = i; 
				in = true;
			};
		

			if( ( src.charAt(i) == endWith ) &&  ( in != false ) && startWithIn == 0 ) { 
				
				e = i; 
				in = false;
				
				result.add( src.substring( s+1, e) );
			}

			if( in && ( src.charAt(i) == endWith ) && startWithIn > 0 ) { 
				startWithIn--; }			
		}

		return result;
	}	
*/	
	public static FilenameFilter filter (final String afn) {
		
		// Creation of anonymous inner class:
			return new FilenameFilter() {
				
				String fn = afn;
			
				public boolean accept(File dir, String n) {
					
					String fullname = null;

					try {

						fullname =  dir.getCanonicalPath() + System.getProperty("file.separator") + n;

					} catch (IOException e) {

						// TODO Auto-generated catch block
						e.printStackTrace();
					}
					
					File fl = new File(fullname);
					
					if( fl.isDirectory() ) { return true; } // on filtre sur les rpertoires
					
					String f = fl.getName();
					
					return Function.isStringIn( f, fn ); // et les fichier d'extention 'afn'
				}
				
			}; // End of anonymous inner class
	}	
	
	public static Vector traverse( File f, Vector liste ) {
		
		if ( f.isDirectory() ) {
			
			String[] children = f.list( filter(".log") );
			
			for (int i=0; i<children.length; i++) {
				
				traverse( new File(f, children[i]), liste );
			}

		} else {

			liste.add( f.getAbsolutePath() );
		}
		
		return liste;
	}	
	
	
	
	
	// Recheche de la prsence d'une chane dans une autre chane
	// isStringIn( hello.log001, .log ) -> true
	// isStringIn( hello.log001, .xml ) -> false

	public static boolean isStringIn( String src, String search ) {
		
		boolean found = false;
		boolean in = false;
		
		int a = 0;
		int b = 0;
		
		while( a < src.length() && ! found ) {
			
			if( src.charAt(a) == search.charAt(b) ) {
				
				in = true;

				a++;
				b++;
				
				while( a < src.length() && b < search.length() && in ) { // parcours de search
					
					if( src.charAt(a) != search.charAt(b) ) {
						
						in = false;
						
					} else { a++; b++; }
				}
				
				if( b == search.length() ) 	{ found = true; } 	// arret de la recherche
					
				b = 0;
				
			} else { a++; }
		}
		
		return found;
	}	

	public static boolean isNumerical( String str ) {
	
		boolean isNumeric = false;
		
		String value = str;
		
		value = value.trim();
		isNumeric = Function.isInteger( value );
		
		return isNumeric;
	}
	
	public static boolean isInteger(String s) {
		
	  char[] sChars = s.toCharArray();
	  
	  for (int i = 0; i < sChars.length; i++)
		  
		  if ( ! Character.isDigit(sChars[i])  )
	    	
	      return false;
	  
	  return true;
	}
	
	public static String replace( String str, String pattern, String replace) {
		
		int s = 0;
		int e = 0;
		
		StringBuffer result = new StringBuffer();
		
		while ((e = str.indexOf(pattern, s)) >= 0) {
			
			result.append(str.substring(s, e));
			result.append(replace);
			s = e + pattern.length();
		}
		
		result.append(str.substring(s));
		return result.toString();
	}
	

	// Test.replace( "oHello Worldo", 'o', "OO" ) --> "OOHellOO WOOrldOO"
	public static String replace( String str, char pattern, String replace) {
		
		int s = 0;
		int e = 0;
		
		StringBuffer result = new StringBuffer();
		
		for( s = 0; s < str.length(); s++ ) {
			
			if( str.charAt(s) == pattern ) { 
				
				result.append( str.substring( e, s) + replace ); 
				if( s < str.length()-1 ) { 
					
					s++; } 
				e = s; 
			}
			
		}

		if( s != 0 && str.charAt(s-1) != pattern ) { 

			result.append( str.substring( e, str.length() )); 
		}
		
		return result.toString();
	}	


}
