package wls.tools.logreport;

import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Vector;

public class Record {
	
	public String fileName = new String();		// le nom du fichier origine
	public int nombreOccurance = 0;				// Le nombre d'occurence rencontr
	public Vector champs = null;				// les information du message d'erreur
	public int key = 0;							// la clef (gestion interne) de l'enregistrement (galement le nom du fichier)
	public ErrorMessage errorMessage = null;	// l'information support BEA 
	
	public BufferedWriter occuranceLogFile = null; // le fichier des occurances 
	public String occuranceLogFileName = null;		// le nom du fichie occurance
		
	public Hashtable dictionnary = new Hashtable(); // dictionnaire de comparaison partiel de record

	/*
	 * Ecriture des diffrentes occurances d'un mme type de record dans un fichier 
	 */
	
	public void recordToOccuranceLog( Record record ) {
		
		if( Parameter.occuranceLog ) {
			
			try {
				
				this.occuranceLogFile.write( record.toDetail() );
				
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
	}	

	/*
	 * parametrer les recorde si on les ajoute dans le report
	 */
	
	public void newAdded( int key, String rootDirectory ) {
		
		this.key = key; // setting de la clef primaire
		
		if( Parameter.occuranceLog ) { // dans le cas ou l'on veut logger tous les types de record du mme type
		
			try {
				
				this.occuranceLogFileName = rootDirectory + System.getProperty("file.separator") + key + ".log";
				this.occuranceLogFile = new BufferedWriter( new FileWriter( this.occuranceLogFileName ) );
				
			} catch (IOException e) {
				
				e.printStackTrace();
			}			
		}
	}
	
	/*
	 * Fermeture des ressources 
	 */
	
	public void closeRecordRessources() {
		
		if( Parameter.occuranceLog ) { // dans le cas ou l'on veut logger tous les types de record du mme type
		
			try {
				
				this.occuranceLogFile.close();
				
			} catch (IOException e) {
				
				// TODO Auto-generated catch block
				e.printStackTrace();
			}			
		}
	}

	/*
	 * constructeur
	 */
	
	public Record( String xfileName, int xoccurance, Vector xchamps ) {
	
		super();
		
		this.fileName = xfileName;
		this.nombreOccurance = xoccurance;
		this.champs = xchamps;		

		// creation du dictionnaire pour les comparaisons approximative
//try {
		String[] items = null;
		
		if(champs.size() <= Parameter.MESSAGE_TEXT ) { 
			
//			System.err.println(">>>>"+champs);
			while( champs.size() <= Parameter.MESSAGE_TEXT ) { 
				champs.add("");
			}
		
		}
		
		items = ( (String) champs.get(Parameter.MESSAGE_TEXT) ).trim().split("\\W");
		
		Hashtable h = new Hashtable();
		
		if( items != null ) {
			
			for (int i = 0; i < items.length; i++) {
				
				if( items[i].length() != 0 ) { h.put( items[i], items[i] ); }
			}
		}
		
		this.dictionnary = h;	
/*} catch (Exception e) {
	e.printStackTrace();
	System.out.println(xchamps);
}*/
	}

	/*
	 * comparaison approxim
	 */
	
	public boolean equalsApproximate( Record compare, float percentApproximate, int stackDepth ) {
	
		boolean isEqual = true;
//		String valeurA = null;
//		String ValeurB = null;
		
//		valeurA = (String) this.champs.elementAt(1);
//		ValeurB = (String) compare.champs.elementAt(1);
		
		if( stackDepth == 0 ) stackDepth = compare.dictionnary.size();
		int depth = stackDepth;
		
		// comparaison des ID de log WLS
		if( this.champs.elementAt(Parameter.MESSAGE_ID).toString().equals( compare.champs.elementAt(Parameter.MESSAGE_ID).toString() ) && isEqual ) { isEqual = true; }
		else { isEqual = false; }

		if( isEqual ) {
		
			if( Parameter.exactMatch ) {
	
				isEqual = this.champs.elementAt(Parameter.MESSAGE_TEXT).toString().equals( compare.champs.elementAt(Parameter.MESSAGE_TEXT).toString() );
				
			} else {
				
				int count = 0;
				String chaineCompare = null;
		
				//for( Enumeration iter = compare.dictionnary.keys(); iter.hasMoreElements(); ) {
				for( Enumeration iter = compare.dictionnary.keys(); iter.hasMoreElements() && depth != 0; ) {
				
					chaineCompare = (String) iter.nextElement();
					if( this.dictionnary.containsKey( chaineCompare ) ) { count++; }	
					depth--;
				}			
				
				if( compare.dictionnary.size() == 0 && this.dictionnary.size() == 0 ) {
					
					isEqual = true;
					
				} else {
					
			 		// float total = this.dictionnary.size();
					float total = stackDepth;
			 		float diff = (float) (total - count);
//			 		float a = (float) ( diff / total );
			 		float percent = ( ( diff / total ) * 100 ) ;	 		
			
					if( ( percent <  percentApproximate ) && isEqual ) { isEqual = true; }
					else { isEqual = false; }
				}
			}
		}
		
//if(isEqual) { Parameter.debug("Record:equalsApproximate:TRUE");  Parameter.debug(compare.toString());}
				
		return isEqual;
	}

	/*
	 * incrment
	 */
	
	public void inc() {
		
		this.nombreOccurance++;
	}
	
	/*
	 *  Affichage ASCII 
	 */
	
	public String toString() {
	
		StringBuffer result = new StringBuffer();

		result.append( this.key ); result.append( "|" );
		result.append( this.fileName ); result.append( "|" );
		result.append( this.nombreOccurance ); result.append( "|" );
		
		if( ! ( this.champs.size() == 0 ) ) { 
			
			int i = 0;
			
			for ( i = 0; i < this.champs.size() - 1; i++) {
				
				result.append( this.champs.elementAt(i) ); result.append( "|" );			
			}

			result.append( this.champs.elementAt(i) ); result.append( "\n" );						
		}
		
		result.append( this.dictionnary );

		return result.toString();
	}
	
	/*
	 * Affichage CVS 
	 */

	public String toCSV() {
		
		StringBuffer result = new StringBuffer();
		String message = null;
		
		result.append( this.key ); result.append( Parameter.sep );
		result.append( "NEW" ); result.append( Parameter.sep );
		result.append( this.fileName ); result.append( Parameter.sep );
		result.append( this.nombreOccurance ); result.append( Parameter.sep );
		
		if( this.champs.size() != 0 ) { 
			
			int i = 0;
			
			for ( i = 0; i < this.champs.size() - 1; i++) {
		
				message = (String) this.champs.elementAt(i);
				
				if( message == null || message.length() == 0 ) { message = " "; }
				
				else { 
				
					message = message.replace( '\n', '#');	
					message = message.replace( '\t', '#');				
					message = Function.replace( message, Parameter.sep, "_" ); 
				}
							
				result.append( message ); result.append( Parameter.sep );
			}

			message = (String) this.champs.elementAt(i);
			
			if( message == null || message.length() == 0 ) { message = " "; }

			else { 
				
				message = message.replace( '\n', '#');	
				message = message.replace( '\t', '#');				
				message = Function.replace( message, Parameter.sep, "_" ); 
			}

//			if( message != null && message.length() > 0 ) { message = Function.replace( message, '\n', " ### " );			}
//			if( message != null && message.length() > 0 ) { message = Function.replace( message, '\t', " ### " );			}
	
			result.append( message ); result.append( Parameter.sep );
			
			if( this.errorMessage == null ) { 
/*				
				try {

					Parameter.unknownIDLog.write( "-----------------------------------------------------------------------\n" );
					Parameter.unknownIDLog.write( this.champs +"\n");
				
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
	*/			
 			} else result.append( this.errorMessage.toCSV() );
		}

		return result.toString();
	}	
	
	public String toDetail() {
		
		StringBuffer result = new StringBuffer();
		
		result.append( this.key ); result.append( "|" );
		result.append( this.fileName ); result.append( "|" );
		result.append( this.nombreOccurance ); result.append( "|" );
		
		if( this.champs.size() != 0 ) { 
			
			int i = 0;
			
			for ( i = 0; i < this.champs.size() - 1; i++) {
				
				result.append( this.champs.elementAt(i) ); result.append( "|" );			
			}

			result.append( this.champs.elementAt(i) ); result.append( "\n" );
		}

		return result.toString();
	}	
	
	/*
	 * Affichage HTML
	 */
	
	public String toReportHtml() {
		
		StringBuffer result = new StringBuffer();
		int i = 0;
		int key = this.key;
		String file = this.fileName;
		int nombreOccurance = this.nombreOccurance;

		String idBEA = null;
		String validityBEA = null;
		String severityBEA = null;
		String severityInfoBEA = null;
		String descriptionBEA = null;
		String causeBEA = null;
		String actionBEA = null;

		if( this.errorMessage != null ) {
			
			idBEA = this.errorMessage.id;
			validityBEA = this.errorMessage.validity;
			severityBEA = this.errorMessage.severity;
			severityInfoBEA = this.errorMessage.severityInfo;
			descriptionBEA = this.errorMessage.description;
			causeBEA = this.errorMessage.cause;
			actionBEA = this.errorMessage.action;

		} else {
			
			idBEA = "";
			validityBEA = "";
			severityBEA = "";
			severityInfoBEA = "";
			descriptionBEA = "";
			causeBEA = "";
			actionBEA = "";
		}

		int taille_cellule_centrage = 20;
		int taille_cellule_gauche = taille_cellule_centrage;
		int taille_cellule_droite=100 - taille_cellule_centrage;
		String color_header = "red";
			
		String header_style_bgcolor = "204, 204, 255"; 		
		String header_gauche_style = "font-style: italic; background-color: rgb(" + header_style_bgcolor + "); font-weight: bold;";
		String header_droite_style = "font-style: italic; background-color: rgb(" + header_style_bgcolor + "); font-weight: bold;";

		String ligne1_style_bgcolor = "255, 255, 204"; 		
		String ligne1_gauche_style = "font-weight: bold; background-color: rgb(" + ligne1_style_bgcolor + ");";
		String ligne1_droite_style = "font-style: italic; background-color: rgb(" + ligne1_style_bgcolor + ");";

		String ligne2_style_bgcolor = ""; 		
		String ligne2_gauche_style = "font-style: bold; font-weight: bold;";
		String ligne2_droite_style = "font-style: italic;";
		
//		style="width: 80%; vertical-align: top; font-weight: bold; background-color: rgb(255, 0, 0);"
			
		/*
style="">1

 */		
		
		// gestion de la couleure de ligne (alterne)
		int ligneX_style = 0;
		String ligne_gauche_style = null;
		String ligne_droite_style = null;		
		
		result.append("<table border=\"0\" cellpadding=\"1\" width=\"100%\">");
		result.append("  <tbody>");
		result.append("    <tr>");

		// HEADER
		
		result.append("      <td style=\"" + header_gauche_style + "\" width=\"" + taille_cellule_gauche + "%\" align=\"right\" valign=\"top\">");
		result.append("      <p class=\"table\"><a href=\"OCC/" + key + ".log\"><b>" + nombreOccurance + "</b></a>");
		result.append("      </p>");
		result.append("      </td>");		
		result.append("      <td style=\"" + header_droite_style + "\" width=\"" + taille_cellule_droite + "%\" valign=\"top\">" + (String) this.champs.elementAt(Parameter.MESSAGE_ID) + "</td>");
		result.append("    </tr>");
		
		int index = 0;
		String libelle = null;
		String value = null;
		
		for( index = 0; index < this.champs.size(); index++ ) {
			
			if( (index != 0) && (index != Parameter.MESSAGE_ID) && (index != Parameter.MESSAGE_TEXT) && (index != Parameter.SEVERITY) ) {

				libelle = (String) Parameter.format.get(index);
//				libelle = (new Integer(index)).toString();
				value = (String) this.champs.get(index);
				
				// gestion de la couleure de ligne (alterne)
				if( ligneX_style++%2 == 0 ) { ligne_gauche_style = ligne2_gauche_style; ligne_droite_style = ligne2_droite_style;}	else { ligne_gauche_style = ligne1_gauche_style; ligne_droite_style = ligne1_droite_style;}				
				
				result.append("    <tr>");
				result.append("      <td style=\"" + ligne_gauche_style + "\" width=\"" + taille_cellule_gauche + "%\" align=\"right\" valign=\"top\">");
				result.append("      <p class=\"table\"><b>" + libelle + "</b>");
				result.append("      </p>");
				result.append("      </td>");
				result.append("      <td style=\"" + ligne_droite_style + "\" width=\"" + taille_cellule_droite + "%\" valign=\"top\">" + value + "</td>");
				result.append("    </tr>");				

			}
		}
		
		
		libelle = (String) Parameter.format.get(Parameter.MESSAGE_TEXT);
		value = (String) this.champs.get(Parameter.MESSAGE_TEXT);
		value = Function.replace( value, '\n', "<br>" );

		// gestion de la couleure de ligne (alterne)
		if( ligneX_style++%2 == 0 ) { ligne_gauche_style = ligne2_gauche_style; ligne_droite_style = ligne2_droite_style;}	else { ligne_gauche_style = ligne1_gauche_style; ligne_droite_style = ligne1_droite_style;}		
		
		result.append("    <tr>");
		result.append("      <td style=\"" + ligne_gauche_style + "\" width=\"" + taille_cellule_gauche + "%\" align=\"right\" valign=\"top\">");
		result.append("      <p class=\"table\"><b>" + libelle + "</b>");
		result.append("      </p>");
		result.append("      </td>");
		result.append("      <td style=\"" + ligne_droite_style + "\" width=\"" + taille_cellule_droite + "%\" valign=\"top\"><small>" + value + "</small></td>");
		result.append("    </tr>");				
		
		// gestion de la couleure de ligne (alterne)
		if( ligneX_style++%2 == 0 ) { ligne_gauche_style = ligne2_gauche_style; ligne_droite_style = ligne2_droite_style;}	else { ligne_gauche_style = ligne1_gauche_style; ligne_droite_style = ligne1_droite_style;}
		
		result.append("    <tr>");
		result.append("      <td style=\"" + ligne_gauche_style + "\" width=\"" + taille_cellule_gauche + "%\" align=\"right\" valign=\"top\">");
		result.append("      <p class=\"table\"><b>" + validityBEA + severityBEA + "</b>");
		result.append("      </p>");
		result.append("      </td>");
		result.append("      <td style=\"" + ligne_droite_style + "\" width=\"" + taille_cellule_droite + "%\" valign=\"top\">" + severityInfoBEA + "</td>");
		result.append("    </tr>");

		// gestion de la couleure de ligne (alterne)
		if( ligneX_style++%2 == 0 ) { ligne_gauche_style = ligne2_gauche_style; ligne_droite_style = ligne2_droite_style;}	else { ligne_gauche_style = ligne1_gauche_style; ligne_droite_style = ligne1_droite_style;}
		
		result.append("    <tr>");
		result.append("      <td style=\"" + ligne_gauche_style + "\" width=\"" + taille_cellule_gauche + "%\" align=\"right\" valign=\"top\">");
		result.append("      <p class=\"table\"><b>Description</b> </p>");
		result.append("      </td>");
		result.append("      <td style=\"" + ligne_droite_style + "\" width=\"" + taille_cellule_droite + "%\" valign=\"top\">" + descriptionBEA + "</td>");
		result.append("    </tr>");

		// gestion de la couleure de ligne (alterne)
		if( ligneX_style++%2 == 0 ) { ligne_gauche_style = ligne2_gauche_style; ligne_droite_style = ligne2_droite_style;}	else { ligne_gauche_style = ligne1_gauche_style; ligne_droite_style = ligne1_droite_style;}
		
		result.append("    <tr>");
		result.append("      <td style=\"" + ligne_gauche_style + "\" width=\"" + taille_cellule_gauche + "%\" align=\"right\" valign=\"top\">");
		result.append("      <p class=\"table\"><b>Cause</b> </p>");
		result.append("      </td>");
		result.append("      <td style=\"" + ligne_droite_style + "\" width=\"" + taille_cellule_droite + "%\" valign=\"top\">" + causeBEA + "</td>");
		result.append("    </tr>");

		// gestion de la couleure de ligne (alterne)
		if( ligneX_style++%2 == 0 ) { ligne_gauche_style = ligne2_gauche_style; ligne_droite_style = ligne2_droite_style;}	else { ligne_gauche_style = ligne1_gauche_style; ligne_droite_style = ligne1_droite_style;}
		
		result.append("    <tr>");
		result.append("      <td style=\"" + ligne_gauche_style + "\" width=\"" + taille_cellule_gauche + "%\" align=\"right\" valign=\"top\">");
		result.append("      <p class=\"table\"><b>Action</b> </p>");
		result.append("      </td>");
		result.append("      <td style=\"" + ligne_droite_style + "\" width=\"" + taille_cellule_droite + "%\" valign=\"top\">" + actionBEA + "</td>");
		result.append("    </tr>");
		
		result.append("  </tbody>");
		result.append("</table>");
		result.append("<br>");	

		return result.toString();
	}	
}
