package wls.tools.logreport;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Locale;
import java.util.Vector;

public class WlsLogReport {

//	public static Parameter parameter = Parameter.getInstance(); // les paramtres de l'outil (ligne de commande)

	/*
	 * Le main de lancement 
	 */	
	
	public static void main(String[] args) {
	
		Parameter parameter = Parameter.getInstance();
		WlsLogReport wlsLogReport = new WlsLogReport();
		Parameter.input( args ); // prise en compte des paramtres en entre
		System.out.println( Parameter.toStringIt() );
		
		try {
			wlsLogReport.doIt();
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} // execution de la commande
	}		

	/*
	 * lecture et traitement des fichiers de logs
	 */
	
	public void doIt() throws Exception {	

		// --- paramtres
		
		StringBuffer ligne = null;		// une ligne de la log
 		Report report = new Report();	// le rapport
		Record record = null;			// un enregistrement du rapport
		
		String str = null;			// une ligne d'un fichier de log
		BufferedReader in = null;	// un fichier de log

		boolean isInRange = true;
		boolean is = false;
		boolean dont = false;
		String messageId = null;
		
		// --- lecture des fichiers de logs
		
		for (int j = 0; j < Parameter.files.size(); j++) { // pour chaque fichiers

			str = null;
			ligne = null;
			Vector champs = null;
			Date currentDate = null;
			
			try {

Parameter.debug("WlsLogReport:doIt:FILE=[" + Parameter.files.elementAt(j)+"]\n");
				
				in = new BufferedReader(new FileReader( (String) Parameter.files.elementAt(j)));

				while ((str = in.readLine()) != null) { // lecture du fichier

					isInRange = true;

					if ( str.length() >= 5 && str.substring(0, Parameter.MESSAGE_START.length() ).equals(Parameter.MESSAGE_START)) { // traitement des bloc avec ####< commme dbut

Parameter.debug("WlsLogReport:doIt:LIGNE={" + str + "}");

						if (ligne != null) { // traitement de la ligne d'avant

							champs = Function.split( ligne.toString(), '<', '>' );
							if(champs.size() > Parameter.format.size() ) { 
								
								report.toErrorLog( (String) Parameter.files.elementAt(j) , ligne.toString() );
								
							} else { this.insert(champs, report, ligne, j); }
						}

						// capture de la ligne suivant

						ligne = new StringBuffer();
						ligne.append(str);

					} else { // concatenation des lignes suivantes du mme bloc
						
						if (ligne != null) { ligne.append( "\n" + str); }
					} 
				}

				// traiter la dernire ligne
				
				if( ligne != null ) {
					
					champs = Function.split( ligne.toString(), '<', '>' );
					
					if(champs.size() > Parameter.format.size() ) { 
						
						report.toErrorLog( (String) Parameter.files.elementAt(j) , ligne.toString() );
						
					} else { this.insert(champs, report, ligne, j); }					
				}
												
				in.close();


			} catch (IOException e) {

				e.printStackTrace();
				System.err.println("Impossible de lire le fichier [" + Parameter.files.elementAt(j) + "]");
				System.exit(1);
			} 
		}
		
		report.closeReport();
		Parameter.close();
	}
	
	
	public void insert( Vector champs, Report report, StringBuffer line, int j ) {

		boolean isInRange = true;
		boolean is = false;
		boolean dont = false;
		String messageId = null;
		Date currentDate = null;
		Record record = null;


		messageId = (String)champs.get(Parameter.MESSAGE_ID);				
		if( ! Parameter.isErrorMessageReferenced(messageId)) { report.toUnknownIDLog((String) Parameter.files.elementAt(j), line.toString()); }
				
		if( !dont && Parameter.excludeId != null ) { // Exclude ID 

			is = Parameter.excludeId.isExclude(messageId);
			dont = is; 
			
			if(is) {report.toExcludeIDLog( (String) Parameter.files.elementAt(j), line.toString());}
		}
			
		try {	
			
			currentDate = Parameter.dateFormat.parse((String) champs.get(0));
			
		} catch (ParseException e1) {

			// forcer en Lang US eng pour le format de date
			
			System.out.println("FORCE DATE FORMAT TO 'US' 'en' 'MMM dd, yyyy hh:mm:ss aaa z'");
			Parameter.country = "US";
			Parameter.language = "en";
			
			Parameter.locale = new Locale(Parameter.language,Parameter.country);
			Parameter.dateFilter = "MMM dd, yyyy hh:mm:ss aaa z";
			Parameter.dateFormat = new SimpleDateFormat("MMM dd, yyyy hh:mm:ss aaa z",Parameter.locale);			
			
			try {
			
				currentDate = Parameter.dateFormat.parse((String) champs.get(0));
				
			} catch (ParseException e2) {			
			
				isInRange = false;
				Date d = new Date();
				System.err.println("WRONG DATE FORMAT {" + champs.get(0) + "} should be like {" + Parameter.dateFilter + "} exemple : " + Parameter.dateFormat.format(d) );
				
				System.exit(1);			
			}
			
		}
		
		if( !dont && Parameter.afterDate != null && Parameter.beforeDate != null ) { // exclude date range 

			if( Parameter.afterDate != null || Parameter.beforeDate != null ) {
				
				if( ! currentDate.after( Parameter.afterDate ) ) { isInRange = false; }
				if( ! currentDate.before( Parameter.beforeDate ) ) { isInRange = false; }
				if( ! isInRange ) { dont = true; }					
			} 
		}	
		
		if( !dont && Parameter.start_houre != null && Parameter.end_houre != null ) { // exclude houre range 
			
			if( Parameter.inRangeHoureToExclude(currentDate) ) { dont = true;}
		}
		
		if( !dont ) { // insert record
				
				report.putDateRange(currentDate);

				record = new Record((String) Parameter.files.elementAt(j), 0, champs );								
				report.pushRecord(record);									
		}
	}
	
}
